package org.cloudgraph.test.datatypes;


import org.plasma.sdo.PlasmaDataObject;

/**
 * Generated interface representing the domain model entity <b>Concurrent</b>. This <a href="http://plasma-sdo.org">SDO</a> interface directly reflects the
 * class (single or multiple) inheritance lattice of the source domain model(s)  and is part of namespace <b>http://cloudgraph.org/test/datatypes</b> defined within the <a href="http://docs.plasma-sdo.org/api/org/plasma/config/package-summary.html">Configuration</a>.
 */
public interface Concurrent extends PlasmaDataObject
{
	/** The <a href="http://plasma-sdo.org">SDO</a> namespace URI associated with the <a href="http://docs.plasma-sdo.org/api/org/plasma/sdo/PlasmaType.html">Type</a> for this class. */
	public static final String NAMESPACE_URI = "http://cloudgraph.org/test/datatypes";

	/** The entity or <a href="http://docs.plasma-sdo.org/api/org/plasma/sdo/PlasmaType.html">Type</a> logical name associated with this class. */
	public static final String TYPE_NAME_CONCURRENT = "Concurrent";
	
	
	
	/**
	 * Represents the logical <a href="http://docs.plasma-sdo.org/api/org/plasma/sdo/PlasmaProperty.html">Property</a> <b>createdOn</b> which is part of the <a href="http://docs.plasma-sdo.org/api/org/plasma/sdo/PlasmaType.html">Type</a> <b>Concurrent</b>.
	 */
	public static final String CREATED_ON = "createdOn";
	
	/**
	 * Represents the logical <a href="http://docs.plasma-sdo.org/api/org/plasma/sdo/PlasmaProperty.html">Property</a> <b>lastModifiedOn</b> which is part of the <a href="http://docs.plasma-sdo.org/api/org/plasma/sdo/PlasmaType.html">Type</a> <b>Concurrent</b>.
	 */
	public static final String LAST_MODIFIED_ON = "lastModifiedOn";
	
	/**
	 * Represents the logical <a href="http://docs.plasma-sdo.org/api/org/plasma/sdo/PlasmaProperty.html">Property</a> <b>lastAccessedOn</b> which is part of the <a href="http://docs.plasma-sdo.org/api/org/plasma/sdo/PlasmaType.html">Type</a> <b>Concurrent</b>.
	 */
	public static final String LAST_ACCESSED_ON = "lastAccessedOn";
	
	/**
	 * Represents the logical <a href="http://docs.plasma-sdo.org/api/org/plasma/sdo/PlasmaProperty.html">Property</a> <b>seqId</b> which is part of the <a href="http://docs.plasma-sdo.org/api/org/plasma/sdo/PlasmaType.html">Type</a> <b>Concurrent</b>.
	 */
	public static final String SEQ_ID = "seqId";
	
	/**
	 * Represents the logical <a href="http://docs.plasma-sdo.org/api/org/plasma/sdo/PlasmaProperty.html">Property</a> <b>createdBy</b> which is part of the <a href="http://docs.plasma-sdo.org/api/org/plasma/sdo/PlasmaType.html">Type</a> <b>Concurrent</b>.
	 */
	public static final String CREATED_BY = "createdBy";
	
	/**
	 * Represents the logical <a href="http://docs.plasma-sdo.org/api/org/plasma/sdo/PlasmaProperty.html">Property</a> <b>lastModifiedBy</b> which is part of the <a href="http://docs.plasma-sdo.org/api/org/plasma/sdo/PlasmaType.html">Type</a> <b>Concurrent</b>.
	 */
	public static final String LAST_MODIFIED_BY = "lastModifiedBy";
	
	/**
	 * Represents the logical <a href="http://docs.plasma-sdo.org/api/org/plasma/sdo/PlasmaProperty.html">Property</a> <b>levelNum</b> which is part of the <a href="http://docs.plasma-sdo.org/api/org/plasma/sdo/PlasmaType.html">Type</a> <b>Concurrent</b>.
	 */
	public static final String LEVEL_NUM = "levelNum";
	
	/**
	 * Represents the logical <a href="http://docs.plasma-sdo.org/api/org/plasma/sdo/PlasmaProperty.html">Property</a> <b>sequenceNum</b> which is part of the <a href="http://docs.plasma-sdo.org/api/org/plasma/sdo/PlasmaType.html">Type</a> <b>Concurrent</b>.
	 */
	public static final String SEQUENCE_NUM = "sequenceNum";
	



	/**
	 * Returns true if the <b>createdOn</b> property is set.
	 * @return true if the <b>createdOn</b> property is set.
	 */
	public boolean isSetCreatedOn();

	/**
	 * Unsets the <b>createdOn</b> property, the value
	 * of the property of the object being set to the property's
	 * default value. The property will no longer be
	 * considered set.
	 */
	public void unsetCreatedOn();

	/**
	 * Returns the value of the <b>createdOn</b> property.
	 * @return the value of the <b>createdOn</b> property.
	 */
	public String getCreatedOn();

	/**
	 * Sets the value of the <b>createdOn</b> property to the given value.
	 */
	public void setCreatedOn(String value);


	/**
	 * Returns true if the <b>lastModifiedOn</b> property is set.
	 * @return true if the <b>lastModifiedOn</b> property is set.
	 */
	public boolean isSetLastModifiedOn();

	/**
	 * Unsets the <b>lastModifiedOn</b> property, the value
	 * of the property of the object being set to the property's
	 * default value. The property will no longer be
	 * considered set.
	 */
	public void unsetLastModifiedOn();

	/**
	 * Returns the value of the <b>lastModifiedOn</b> property.
	 * @return the value of the <b>lastModifiedOn</b> property.
	 */
	public String getLastModifiedOn();

	/**
	 * Sets the value of the <b>lastModifiedOn</b> property to the given value.
	 */
	public void setLastModifiedOn(String value);


	/**
	 * Returns true if the <b>lastAccessedOn</b> property is set.
	 * @return true if the <b>lastAccessedOn</b> property is set.
	 */
	public boolean isSetLastAccessedOn();

	/**
	 * Unsets the <b>lastAccessedOn</b> property, the value
	 * of the property of the object being set to the property's
	 * default value. The property will no longer be
	 * considered set.
	 */
	public void unsetLastAccessedOn();

	/**
	 * Returns the value of the <b>lastAccessedOn</b> property.
	 * @return the value of the <b>lastAccessedOn</b> property.
	 */
	public String getLastAccessedOn();

	/**
	 * Sets the value of the <b>lastAccessedOn</b> property to the given value.
	 */
	public void setLastAccessedOn(String value);


	/**
	 * Returns true if the <b>seqId</b> property is set.
	 * @return true if the <b>seqId</b> property is set.
	 */
	public boolean isSetSeqId();

	/**
	 * Unsets the <b>seqId</b> property, the value
	 * of the property of the object being set to the property's
	 * default value. The property will no longer be
	 * considered set.
	 */
	public void unsetSeqId();

	/**
	 * Returns the value of the <b>seqId</b> property.
	 * @return the value of the <b>seqId</b> property.
	 */
	public long getSeqId();

	/**
	 * Sets the value of the <b>seqId</b> property to the given value.
	 */
	public void setSeqId(long value);


	/**
	 * Returns true if the <b>createdBy</b> property is set.
	 * @return true if the <b>createdBy</b> property is set.
	 */
	public boolean isSetCreatedBy();

	/**
	 * Unsets the <b>createdBy</b> property, the value
	 * of the property of the object being set to the property's
	 * default value. The property will no longer be
	 * considered set.
	 */
	public void unsetCreatedBy();

	/**
	 * Returns the value of the <b>createdBy</b> property.
	 * @return the value of the <b>createdBy</b> property.
	 */
	public String getCreatedBy();

	/**
	 * Sets the value of the <b>createdBy</b> property to the given value.
	 */
	public void setCreatedBy(String value);


	/**
	 * Returns true if the <b>lastModifiedBy</b> property is set.
	 * @return true if the <b>lastModifiedBy</b> property is set.
	 */
	public boolean isSetLastModifiedBy();

	/**
	 * Unsets the <b>lastModifiedBy</b> property, the value
	 * of the property of the object being set to the property's
	 * default value. The property will no longer be
	 * considered set.
	 */
	public void unsetLastModifiedBy();

	/**
	 * Returns the value of the <b>lastModifiedBy</b> property.
	 * @return the value of the <b>lastModifiedBy</b> property.
	 */
	public String getLastModifiedBy();

	/**
	 * Sets the value of the <b>lastModifiedBy</b> property to the given value.
	 */
	public void setLastModifiedBy(String value);


	/**
	 * Returns true if the <b>levelNum</b> property is set.
	 * @return true if the <b>levelNum</b> property is set.
	 */
	public boolean isSetLevelNum();

	/**
	 * Unsets the <b>levelNum</b> property, the value
	 * of the property of the object being set to the property's
	 * default value. The property will no longer be
	 * considered set.
	 */
	public void unsetLevelNum();

	/**
	 * Returns the value of the <b>levelNum</b> property.
	 * @return the value of the <b>levelNum</b> property.
	 */
	public long getLevelNum();

	/**
	 * Sets the value of the <b>levelNum</b> property to the given value.
	 */
	public void setLevelNum(long value);


	/**
	 * Returns true if the <b>sequenceNum</b> property is set.
	 * @return true if the <b>sequenceNum</b> property is set.
	 */
	public boolean isSetSequenceNum();

	/**
	 * Unsets the <b>sequenceNum</b> property, the value
	 * of the property of the object being set to the property's
	 * default value. The property will no longer be
	 * considered set.
	 */
	public void unsetSequenceNum();

	/**
	 * Returns the value of the <b>sequenceNum</b> property.
	 * @return the value of the <b>sequenceNum</b> property.
	 */
	public long getSequenceNum();

	/**
	 * Sets the value of the <b>sequenceNum</b> property to the given value.
	 */
	public void setSequenceNum(long value);
}