package org.cloudgraph.test.datatypes.impl;

import java.io.Serializable;
import org.plasma.sdo.core.CoreDataObject;
import java.lang.String;
import org.cloudgraph.test.datatypes.Concurrent;

/**
 * Generated implementation class representing the domain model entity <b>Concurrent</b>.
 */
public class ConcurrentSDO extends CoreDataObject implements Serializable, Concurrent
{
	private static final long serialVersionUID = 1L;
	/** The SDO namespace URI associated with the SDO Type for this class */
	public static final String NAMESPACE_URI = "http://cloudgraph.org/test/datatypes";

	/**
	 * Default No-arg constructor required for serialization operations. This method
	 * is NOT intended to be used within application source code.
	 */
	public ConcurrentSDO() {
		super();
	}
	public ConcurrentSDO(commonj.sdo.Type type) {
		super(type);
	}


	/**
	 * Returns true if the <b>createdBy</b> property is set.
	 * @return true if the <b>createdBy</b> property is set.
	 */
	public boolean isSetCreatedBy(){
		return super.isSet(Concurrent.CREATED_BY);
	}

	/**
	 * Unsets the <b>createdBy</b> property, the value
	 * of the property of the object being set to the property's
	 * default value. The property will no longer be
	 * considered set.
	 */
	public void unsetCreatedBy(){
		super.unset(Concurrent.CREATED_BY);
	}

	/**
	 * Returns the value of the <b>createdBy</b> property.
	 * @return the value of the <b>createdBy</b> property.
	 */
	public String getCreatedBy(){
		return (String)super.get(Concurrent.CREATED_BY);
	}

	/**
	 * Sets the value of the <b>createdBy</b> property to the given value.
	 */
	public void setCreatedBy(String value){
		super.set(Concurrent.CREATED_BY, value);
	}


	/**
	 * Returns true if the <b>createdOn</b> property is set.
	 * @return true if the <b>createdOn</b> property is set.
	 */
	public boolean isSetCreatedOn(){
		return super.isSet(Concurrent.CREATED_ON);
	}

	/**
	 * Unsets the <b>createdOn</b> property, the value
	 * of the property of the object being set to the property's
	 * default value. The property will no longer be
	 * considered set.
	 */
	public void unsetCreatedOn(){
		super.unset(Concurrent.CREATED_ON);
	}

	/**
	 * Returns the value of the <b>createdOn</b> property.
	 * @return the value of the <b>createdOn</b> property.
	 */
	public String getCreatedOn(){
		return (String)super.get(Concurrent.CREATED_ON);
	}

	/**
	 * Sets the value of the <b>createdOn</b> property to the given value.
	 */
	public void setCreatedOn(String value){
		super.set(Concurrent.CREATED_ON, value);
	}


	/**
	 * Returns true if the <b>lastAccessedOn</b> property is set.
	 * @return true if the <b>lastAccessedOn</b> property is set.
	 */
	public boolean isSetLastAccessedOn(){
		return super.isSet(Concurrent.LAST_ACCESSED_ON);
	}

	/**
	 * Unsets the <b>lastAccessedOn</b> property, the value
	 * of the property of the object being set to the property's
	 * default value. The property will no longer be
	 * considered set.
	 */
	public void unsetLastAccessedOn(){
		super.unset(Concurrent.LAST_ACCESSED_ON);
	}

	/**
	 * Returns the value of the <b>lastAccessedOn</b> property.
	 * @return the value of the <b>lastAccessedOn</b> property.
	 */
	public String getLastAccessedOn(){
		return (String)super.get(Concurrent.LAST_ACCESSED_ON);
	}

	/**
	 * Sets the value of the <b>lastAccessedOn</b> property to the given value.
	 */
	public void setLastAccessedOn(String value){
		super.set(Concurrent.LAST_ACCESSED_ON, value);
	}


	/**
	 * Returns true if the <b>lastModifiedBy</b> property is set.
	 * @return true if the <b>lastModifiedBy</b> property is set.
	 */
	public boolean isSetLastModifiedBy(){
		return super.isSet(Concurrent.LAST_MODIFIED_BY);
	}

	/**
	 * Unsets the <b>lastModifiedBy</b> property, the value
	 * of the property of the object being set to the property's
	 * default value. The property will no longer be
	 * considered set.
	 */
	public void unsetLastModifiedBy(){
		super.unset(Concurrent.LAST_MODIFIED_BY);
	}

	/**
	 * Returns the value of the <b>lastModifiedBy</b> property.
	 * @return the value of the <b>lastModifiedBy</b> property.
	 */
	public String getLastModifiedBy(){
		return (String)super.get(Concurrent.LAST_MODIFIED_BY);
	}

	/**
	 * Sets the value of the <b>lastModifiedBy</b> property to the given value.
	 */
	public void setLastModifiedBy(String value){
		super.set(Concurrent.LAST_MODIFIED_BY, value);
	}


	/**
	 * Returns true if the <b>lastModifiedOn</b> property is set.
	 * @return true if the <b>lastModifiedOn</b> property is set.
	 */
	public boolean isSetLastModifiedOn(){
		return super.isSet(Concurrent.LAST_MODIFIED_ON);
	}

	/**
	 * Unsets the <b>lastModifiedOn</b> property, the value
	 * of the property of the object being set to the property's
	 * default value. The property will no longer be
	 * considered set.
	 */
	public void unsetLastModifiedOn(){
		super.unset(Concurrent.LAST_MODIFIED_ON);
	}

	/**
	 * Returns the value of the <b>lastModifiedOn</b> property.
	 * @return the value of the <b>lastModifiedOn</b> property.
	 */
	public String getLastModifiedOn(){
		return (String)super.get(Concurrent.LAST_MODIFIED_ON);
	}

	/**
	 * Sets the value of the <b>lastModifiedOn</b> property to the given value.
	 */
	public void setLastModifiedOn(String value){
		super.set(Concurrent.LAST_MODIFIED_ON, value);
	}


	/**
	 * Returns true if the <b>levelNum</b> property is set.
	 * @return true if the <b>levelNum</b> property is set.
	 */
	public boolean isSetLevelNum(){
		return super.isSet(Concurrent.LEVEL_NUM);
	}

	/**
	 * Unsets the <b>levelNum</b> property, the value
	 * of the property of the object being set to the property's
	 * default value. The property will no longer be
	 * considered set.
	 */
	public void unsetLevelNum(){
		super.unset(Concurrent.LEVEL_NUM);
	}

	/**
	 * Returns the value of the <b>levelNum</b> property.
	 * @return the value of the <b>levelNum</b> property.
	 */
	public long getLevelNum(){
		Long result = (Long)super.get(Concurrent.LEVEL_NUM);
		if (result != null)
			return result.longValue();
		else return 0;
	}

	/**
	 * Sets the value of the <b>levelNum</b> property to the given value.
	 */
	public void setLevelNum(long value){
		super.set(Concurrent.LEVEL_NUM, value);
	}


	/**
	 * Returns true if the <b>seqId</b> property is set.
	 * @return true if the <b>seqId</b> property is set.
	 */
	public boolean isSetSeqId(){
		return super.isSet(Concurrent.SEQ_ID);
	}

	/**
	 * Unsets the <b>seqId</b> property, the value
	 * of the property of the object being set to the property's
	 * default value. The property will no longer be
	 * considered set.
	 */
	public void unsetSeqId(){
		super.unset(Concurrent.SEQ_ID);
	}

	/**
	 * Returns the value of the <b>seqId</b> property.
	 * @return the value of the <b>seqId</b> property.
	 */
	public long getSeqId(){
		Long result = (Long)super.get(Concurrent.SEQ_ID);
		if (result != null)
			return result.longValue();
		else return 0;
	}

	/**
	 * Sets the value of the <b>seqId</b> property to the given value.
	 */
	public void setSeqId(long value){
		super.set(Concurrent.SEQ_ID, value);
	}


	/**
	 * Returns true if the <b>sequenceNum</b> property is set.
	 * @return true if the <b>sequenceNum</b> property is set.
	 */
	public boolean isSetSequenceNum(){
		return super.isSet(Concurrent.SEQUENCE_NUM);
	}

	/**
	 * Unsets the <b>sequenceNum</b> property, the value
	 * of the property of the object being set to the property's
	 * default value. The property will no longer be
	 * considered set.
	 */
	public void unsetSequenceNum(){
		super.unset(Concurrent.SEQUENCE_NUM);
	}

	/**
	 * Returns the value of the <b>sequenceNum</b> property.
	 * @return the value of the <b>sequenceNum</b> property.
	 */
	public long getSequenceNum(){
		Long result = (Long)super.get(Concurrent.SEQUENCE_NUM);
		if (result != null)
			return result.longValue();
		else return 0;
	}

	/**
	 * Sets the value of the <b>sequenceNum</b> property to the given value.
	 */
	public void setSequenceNum(long value){
		super.set(Concurrent.SEQUENCE_NUM, value);
	}
}